// Rob McDermott			21 August 2004
// 159.776 Visual Languages and Graphics	Assignment 4
// Robots cheerleaders, spelling out 'IIST'.
// Built using hierarchical modelling.
// -------------------------------------------------------------

#pragma hdrstop
#include <condefs.h>
#include <iostream.h>
#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <gl/Gl.h>
#include <gl/glut.h>

//---------------------------------------------------------------------------
#pragma argsused

#define floor 1 	// id for list of commands for floor
#define fieldMarkings 2
#define goalPost 3
#define PI 3.1415926535898

#define TORSO_HEIGHT 2.0
#define TORSO_RADIUS 1.5
#define UPPER_ARM_HEIGHT 2.0
#define UPPER_ARM_RADIUS  0.5
#define LOWER_ARM_HEIGHT 2.0
#define LOWER_ARM_RADIUS  0.4
#define UPPER_LEG_RADIUS  0.8
#define UPPER_LEG_HEIGHT 3.0
#define LOWER_LEG_RADIUS  0.7
#define LOWER_LEG_HEIGHT 3.0
#define HEAD_HEIGHT 1.2
#define HEAD_RADIUS 0.9
#define Y_COORD 0.4         // as long as robot stands on the grass, this never changes

// offsets for the commands
#define WALK_SIZE 4 // a walk command uses 4 positions of the commands array
#define WALK_XCOORD_OFFSET 1
#define WALK_YCOORD_OFFSET 2
#define WALK_ZCOORD_OFFSET 3
#define SPELL_LETTER_SIZE 14 // a spell-letter command uses 12 positions of the commands array
#define SPELL_TORSO_OFFSET 1
#define SPELL_HEAD_NOD_OFFSET 2
#define SPELL_HEAD_TURN_OFFSET 3
#define SPELL_LUA_FRONT_OFFSET 4
#define SPELL_LLA_OFFSET 5
#define SPELL_RUA_FRONT_OFFSET 6
#define SPELL_RLA_OFFSET 7
#define SPELL_LUL_OFFSET 8
#define SPELL_LLL_OFFSET 9
#define SPELL_RUL_OFFSET 10
#define SPELL_RLL_OFFSET 11
#define SPELL_LUA_SIDE_OFFSET 12
#define SPELL_RUA_SIDE_OFFSET 13

#define NBR_ROBOTS 4    // 4 robots


// variable declarations ---------------------------

GLuint  window, viewingWindow, textWindow;	// variables to identify the window
const float piover180 = 0.0174532925f;
float heading, xpos;
float zpos = 5.0;				// initially locate viewer 5 units back from center
GLfloat	yrot;
GLfloat walkbias = 0.0;
GLfloat walkbiasangle = 0.0;
GLfloat lookupdown = 0.0;
GLfloat light0_pos[] ={10.0,3.0,10.0,0.0};	// light is a distant source
enum materialTypes {robot,theFloor,theWalls,theCeiling,theLight,lineMarkings, theGoalPost} myMaterial; //e.g myMaterial = theFloor
GLuint texture;		// Storage for a texture
GLuint texture1;
int Width, Height;
unsigned int textures[NBR_ROBOTS];
GLfloat lightRotation = 0.0;
GLfloat robotX[NBR_ROBOTS] = {-3.0,-1.0,0.5,3.0};      // coords of each robot
GLfloat robotY[NBR_ROBOTS] = {Y_COORD,Y_COORD,Y_COORD,Y_COORD};
GLfloat robotZ[NBR_ROBOTS] = {-2.0,-6.0,-10.0,-12.0};
boolean pause = false;

	// initial positions of joints
static GLfloat theta[][13] = {
                            // init joint pos for first robot
                            {0.0,	//0. torso
							0.0,	//1. head nod
                            0.0,	//2. head turn
                            180.0,	//3. left upper arm, rotate in plane to front of body
                            0.0,	//4. left lower arm
                            180.0,	//5. right upper arm, rotate in plane to side of body
                            0.0,	//6. right lower arm
                            180.0,	//7. left upper leg
                            0.0,	//8. left lower leg
                            180.0,	//9. right upper leg
                            0.0,	//10. right lower leg
                            0.0,	//3. left upper arm, rotate in plane to side of body
                            0.0},	//3. right upper arm, rotate in plane to side of body
                            // init joint pos for second robot
                            {0.0,	//0. torso
							0.0,	//1. head nod
                            0.0,	//2. head turn
                            180.0,	//3. left upper arm, rotate in plane to front of body
                            0.0,	//4. left lower arm
                            180.0,	//5. right upper arm, rotate in plane to side of body
                            0.0,	//6. right lower arm
                            180.0,	//7. left upper leg
                            0.0,	//8. left lower leg
                            180.0,	//9. right upper leg
                            0.0,	//10. right lower leg
                            0.0,	//3. left upper arm, rotate in plane to side of body
                            0.0},    //3. right upper arm, rotate in plane to side of body
                            // init joint pos for third robot
                            {0.0,	//0. torso
							0.0,	//1. head nod
                            0.0,	//2. head turn
                            180.0,	//3. left upper arm, rotate in plane to front of body
                            0.0,	//4. left lower arm
                            180.0,	//5. right upper arm, rotate in plane to side of body
                            0.0,	//6. right lower arm
                            180.0,	//7. left upper leg
                            0.0,	//8. left lower leg
                            180.0,	//9. right upper leg
                            0.0,	//10. right lower leg
                            0.0,	//3. left upper arm, rotate in plane to side of body
                            0.0},    //3. right upper arm, rotate in plane to side of body
                            // init joint pos for fourth robot
                            {0.0,	//0. torso
							0.0,	//1. head nod
                            0.0,	//2. head turn
                            180.0,	//3. left upper arm, rotate in plane to front of body
                            0.0,	//4. left lower arm
                            180.0,	//5. right upper arm, rotate in plane to side of body
                            0.0,	//6. right lower arm
                            180.0,	//7. left upper leg
                            0.0,	//8. left lower leg
                            180.0,	//9. right upper leg
                            0.0,	//10. right lower leg
                            0.0,	//3. left upper arm, rotate in plane to side of body
                            0.0}    //3. right upper arm, rotate in plane to side of body
                            };  // end of joint pos

	// pointers to graphics objects for the robot body parts
GLUquadricObj *t,*t1, *h, *lua, *lla, *rua, *rla, *lll, *rll, *rul, *lul;
GLUquadricObj *upRight, *crossBar, *leftPost, *rightPost;
bool nodDown[NBR_ROBOTS] = {true,true,true,true};
bool stepUpperLeg[NBR_ROBOTS] = {true,false,true,false};
bool stepLowerLeg[NBR_ROBOTS] = {true,false,true,false};
bool swingArms[NBR_ROBOTS] = {true,false,true,false};
	// commands that tell the robot what to do during the idle() callback...
GLuint currentCommand[NBR_ROBOTS] = {0,0,0,0};  // array index pos of command we are currently executing
GLuint nbrCommands = 2; // each robot will have 2 commands (walk up, then spell a letter)
GLuint commandsCompleted[NBR_ROBOTS] = {0,0,0,0};
static GLfloat commands[NBR_ROBOTS][18] =  {
                                // commands for the first robot...
                                {1.0,    // command: walk
                                -3.0,    //  target x coordinate for this walk command
                                Y_COORD,    // target y coordinate for this walk command
                                0.0,        // target z coordinate for this walk command
                                2.0,    // command: spell a letter (in this case, an 'I')
                                0.0,	    // target torso angle
							    0.0,	    // target head nod
                                0.0,	    // target head turn
                                0.0,	    // target left upper arm, in a plane to front of body
                                0.0,	    // target left lower arm
                                0.0,	    // target right upper arm, in a plane to front of body
                                0.0,	    // target right lower arm
                                180.0,	    // target left upper leg
                                0.0,	    // target left lower leg
                                180.0,	    // target right upper leg
                                0.0,	    // target right lower leg
                                0.0,	    // target left upper arm, in a plane to side of body
                                0.0},	    // target right upper arm, in a plane to side of body
                                // commands for the second robot...
                                {1.0,    // command: walk
                                -1.0,    //  target x coordinate for this walk command
                                Y_COORD,    // target y coordinate for this walk command
                                0.0,        // target z coordinate for this walk command
                                2.0,    // command: spell a letter (in this case, an 'I')
                                0.0,	    // target torso angle
							    0.0,	    // target head nod
                                0.0,	    // target head turn
                                0.0,	    // target left upper arm
                                0.0,	    // target left lower arm
                                0.0,	    // target right upper arm
                                0.0,	    // target right lower arm
                                180.0,	    // target left upper leg
                                0.0,	    // target left lower leg
                                180.0,	    // target right upper leg
                                0.0,	    // target right lower leg
                                0.0,	    // target left upper arm, in a plane to side of body
                                0.0},	    // target right upper arm, in a plane to side of body
                                // commands for the third robot...
                                {1.0,    // command: walk
                                0.5,    //  target x coordinate for this walk command
                                Y_COORD,    // target y coordinate for this walk command
                                0.0,        // target z coordinate for this walk command
                                2.0,    // command: spell a letter (in this case, an 'S')
                                90.0,	    // target torso angle   facing the right
							    80.0,	    // target head nod
                                0.0,	    // target head turn
                                90.0,	    // target left upper arm    horizontal, in front of body
                                0.0,	    // target left lower arm    down slightly
                                90.0,	    // target right upper arm   horizontal, in front of body
                                0.0,	    // target right lower arm   down slightly
                                135.0,	    // target left upper leg    bent forward
                                135.0,	    // target left lower leg    bent back
                                135.0,	    // target right upper leg   bent forward
                                135.0,	    // target right lower leg   bent back
                                0.0,	    // target left upper arm, in a plane to side of body
                                0.0},	    // target right upper arm, in a plane to side of body
                                // commands for the fourth robot...
                                {1.0,    // command: walk
                                3.0,    //  target x coordinate for this walk command
                                Y_COORD,    // target y coordinate for this walk command
                                0.0,        // target z coordinate for this walk command
                                2.0,    // command: spell a letter (in this case, a 'T')
                                0.0,	    // target torso angle
							    0.0,	    // target head nod
                                0.0,	    // target head turn
                                90.0,	    // target left upper arm    horizontal NB need to rotate it to the side
                                0.0,	    // target left lower arm
                                90.0,	    // target right upper arm   horizontal, in front of body
                                0.0,	    // target right lower arm
                                180.0,	    // target left upper leg
                                0.0,	    // target left lower leg
                                180.0,	    // target right upper leg
                                0.0,	    // target right lower leg
                                90.0,	    // target left upper arm, in a plane to side of body
                                -90.0}	    // target right upper arm, in a plane to side of body
                                }; // end of robot commands


// user-defined types ------------------------------
typedef struct treenode
{
	GLfloat m[16];      // matrix
    void (*f)();		// function that draws the object
    struct treenode *sibling;
    struct treenode *child;
} treenode;

treenode torso_node[NBR_ROBOTS],head_node[NBR_ROBOTS],lua_node[NBR_ROBOTS],
        rua_node[NBR_ROBOTS],lla_node[NBR_ROBOTS],rla_node[NBR_ROBOTS],
		lul_node[NBR_ROBOTS],rul_node[NBR_ROBOTS],lll_node[NBR_ROBOTS],rll_node[NBR_ROBOTS];


// global data -------------------------------------

	// material properties
	GLfloat mat_specular[][4]={ {0.6,0.5,0.2,1.0}, // IIST material
								{0.9,0.9,0.9,1.0}, // floor material
                                {0.7,0.8,0.9,1.0}, // wall material
                                {0.9,0.9,0.9,1.0}, // ceiling material
                                {1.0,1.0,1.0,1.0}, // the light source
                                {1.0,1.0,1.0,1.0}}; // the line markings
	GLfloat mat_diffuse[][4]= { {0.8,0.6,0.4,1.0}, // IIST material
								{0.4,0.9,0.4,1.0}, // floor material
                                {0.4,0.5,0.9,1.0}, // wall material
                                {0.9,0.9,0.9,1.0}, // ceiling material
                                {1.0,1.0,1.0,1.0}, // the light source
                                {1.0,1.0,1.0,1.0}}; // the line markings
    GLfloat mat_ambient[][4]={  {0.6,0.4,0.5,1.0}, // IIST material
								{0.3,0.8,0.3,1.0}, // floor material
                                {0.2,0.5,0.8,1.0}, // wall material
                                {0.9,0.9,0.9,0.2}, // ceiling material
                                {1.0,1.0,1.0,1.0}, // the light source
                                {1.0,1.0,1.0,1.0}}; // the line markings
    GLfloat mat_shininess[6]={  60.0, // IIST material
								40.0, // floor material
                                100.0, // wall material
                                70.0, // ceiling material
                                100.0, // the light source
                                100.0}; // the line markings
	GLfloat mat_emission[][4]={ {0.0,0.0,0.0,1.0}, // IIST material
								{0.0,0.0,0.0,1.0}, // floor material
                                {0.0,0.0,0.0,1.0}, // wall material
                                {0.0,0.0,0.0,1.0}, // ceiling material
                                {1.0,1.0,1.0,1.0}, // the light source
                                {0.0,0.0,0.0,0.0}}; // the line markings


// function declarations
void setMaterial(int type);
void redisplayAll(void);
void drawstr(GLvoid *font, GLfloat x, GLfloat y, char* format, ...);
bool NeHeLoadBitmap(LPTSTR szFileName, GLuint &texid);
void floorTexture(void);
void traverse(treenode* root);
void head();
void torso();
void left_upper_arm();
void right_upper_arm();
void left_upper_leg();
void right_upper_leg();
void goalPostObject(void);

// function implementation ------------------------------------------


void myReshape(int w, int h)
{
	/* NB: setting up a perspective viewing volume:
     * glFrustum(xmin,xmax,ymin,ymax,near,far) where...
     * near and far distances must both be positive, and are measured
     * from the centre of projection (the centre of the camera lens/eye)
     */

	glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if (w<=h)
    	glFrustum(-2.0,2.0,-2.0*(GLfloat)h/(GLfloat)w,2.0*(GLfloat)h/(GLfloat)w,2.0,40.0);
    else
        glFrustum(-2.0,2.0,-2.0*(GLfloat)w/(GLfloat)h,2.0*(GLfloat)w/(GLfloat)h,2.0,40.0);

    glMatrixMode(GL_MODELVIEW);
}

void redisplayAll(void)
{
    glutSetWindow(viewingWindow);
    glutPostRedisplay();
}

void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
    glClearColor(0.1,0.5,0.9,0.0);	// sky blue background
	glLoadIdentity();

    // tweak the matrix... to move the viewer around the scene (actually, move the scene around viewer)
    GLfloat xtrans = -xpos;
	GLfloat ztrans = -zpos;
	GLfloat ytrans = -walkbias-0.25f;
	GLfloat sceneroty = 360.0f - yrot;
	glRotatef(lookupdown,1.0f,0,0);
	glRotatef(sceneroty,0,1.0f,0);
	glTranslatef(xtrans, ytrans, ztrans);


    // and now draw the desired objects...

    // 0. position the light source, to resemble the sun
    glLightfv(GL_LIGHT0,GL_POSITION,light0_pos); // light is a distant source (the sun)

    // Now the robots
	myMaterial = robot;
 	setMaterial(myMaterial);

    glEnable(GL_TEXTURE_2D);
    for (int i=0;i<NBR_ROBOTS;i++)
    {
        glBindTexture( GL_TEXTURE_2D, textures[i]); // each robot has a different texture
        // draw a robot
        glPushMatrix();
        glTranslatef(robotX[i],robotY[i],robotZ[i]);	// where in the room is the robot?
        glScalef(0.2,0.4,0.2);	// how big is the robot?

        traverse(&torso_node[i]);	// traverse the robot tree, drawing each body part
        glPopMatrix();	// restore matrix
    } // end for each robot



    //5. the field
    	// apply grass texture to the field
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, textures[3]);

		// specify the material properties of the field
	myMaterial = theFloor;
 	setMaterial(myMaterial);
    	// lay the field down
	glPushMatrix();
    glTranslatef(0.0,-3.0,0.0);
    glScalef(15.0,0.0,20.0);
    glCallList(floor);
    glPopMatrix();

    	// white lines on the field
    glDisable(GL_TEXTURE_2D); // don't texture the lines
    myMaterial = lineMarkings;
    setMaterial(myMaterial);
    glPushMatrix();
    glCallList(fieldMarkings);
    glPopMatrix();

    // goal posts
    glPushMatrix();
    glTranslatef(0.0,-3.0,-18.0);	// where is the goal post?
    goalPostObject();
    glPopMatrix();

    glPushMatrix();
    glTranslatef(0.0,-3.0,18.0);	// where is the goal post?
    goalPostObject();
    glPopMatrix();


	glFlush();
	glutSwapBuffers();
}

void textReshape(int w, int h)
{
	glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
   	gluOrtho2D(0.0,300,0.0,100);  //xMin,xMax,yMin,yMax
    glMatrixMode(GL_MODELVIEW);
}

void traverse(treenode* root)
{
   if(root==NULL) return;
   glPushMatrix();
   glMultMatrixf(root->m);
   root->f();
   if(root->child!=NULL) traverse(root->child);
   glPopMatrix();
   if(root->sibling!=NULL) traverse(root->sibling);
}

	// functions to draw each robot body part -----------
void torso()
{
   glPushMatrix();
   glScalef(TORSO_RADIUS, TORSO_HEIGHT, 0.7*TORSO_RADIUS);
   gluSphere(t,1.0,10,10);
   glPopMatrix();
   glPushMatrix();
   glScalef(0.9*TORSO_HEIGHT,0.6*TORSO_RADIUS, 0.8*TORSO_RADIUS);
   glTranslatef(0.0,0.7*TORSO_HEIGHT,0.0);
   gluSphere(t1,1.0,10,10);	// shoulder area is a wider sphere
   glPopMatrix();
}

void head()
{
   glPushMatrix();
   glTranslatef(0.0, 0.5*HEAD_HEIGHT,0.0);
   glScalef(HEAD_RADIUS, HEAD_HEIGHT, HEAD_RADIUS);
   gluSphere(h,1.0,10,10);
   glPopMatrix();
}

void left_upper_arm()
{
   glPushMatrix();
   glTranslatef(0.0, 0.7*UPPER_ARM_HEIGHT,0.0);
   glScalef(UPPER_ARM_RADIUS, UPPER_ARM_HEIGHT, UPPER_ARM_RADIUS);
   gluSphere(lua,1.0,5,5);	// OBJ*, radius, slices, stacks
   glPopMatrix();
}

void left_lower_arm()
{
   glPushMatrix();
   glRotatef(-90.0, 1.0, 0.0, 0.0);
   gluCylinder(lla,LOWER_ARM_RADIUS, LOWER_ARM_RADIUS, LOWER_ARM_HEIGHT,10,10);
   glPopMatrix();
}

void right_upper_arm()
{
   glPushMatrix();
   glTranslatef(0.0, 0.7*UPPER_ARM_HEIGHT,0.0);
   glScalef(UPPER_ARM_RADIUS, UPPER_ARM_HEIGHT, UPPER_ARM_RADIUS);
   gluSphere(rua,1.0,5,5);	// OBJ*, radius, slices, stacks
   glPopMatrix();
}

void right_lower_arm()
{
   glPushMatrix();
   glRotatef(-90.0, 1.0, 0.0, 0.0);
   gluCylinder(rla,LOWER_ARM_RADIUS, LOWER_ARM_RADIUS, LOWER_ARM_HEIGHT,10,10);
   glPopMatrix();
}

void left_upper_leg()
{
   glPushMatrix();
   glTranslatef(0.0, 0.7*UPPER_LEG_HEIGHT,0.0);
   glScalef(UPPER_LEG_RADIUS, UPPER_LEG_HEIGHT, UPPER_LEG_RADIUS);
   gluSphere(lul,1.0,5,5);	// OBJ*, radius, slices, stacks
   glPopMatrix();
}

void left_lower_leg()
{
   glPushMatrix();
   glRotatef(-90.0, 1.0, 0.0, 0.0);
   gluCylinder(lll,LOWER_LEG_RADIUS, LOWER_LEG_RADIUS, LOWER_LEG_HEIGHT,10,10);
   glPopMatrix();
}

void right_upper_leg()
{
   glPushMatrix();
   glTranslatef(0.0, 0.7*UPPER_LEG_HEIGHT,0.0);
   glScalef(UPPER_LEG_RADIUS, UPPER_LEG_HEIGHT, UPPER_LEG_RADIUS);
   gluSphere(rul,1.0,5,5);	// OBJ*, radius, slices, stacks
   glPopMatrix();
}

void right_lower_leg()
{
   glPushMatrix();
   glRotatef(-90.0, 1.0, 0.0, 0.0);
   gluCylinder(rll,LOWER_LEG_RADIUS, LOWER_LEG_RADIUS, LOWER_LEG_HEIGHT,10,10);
   glPopMatrix();
}


void goalPostObject()
{
    //upRight, crossBar, leftPost, rightPost;
    // upright
    glPushMatrix();
	glRotatef(-90.0, 1.0, 0.0, 0.0);
   	gluCylinder(upRight,0.1,0.1,2.0,10,10);	//radius,radius,height,slices,slices
    glPopMatrix();
    // crossBar
    glPushMatrix();
    glTranslatef(-1.5,2.0,0.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
   	gluCylinder(crossBar,0.1,0.1,3.0,10,10);	//radius,radius,height,slices,slices
    glPopMatrix();
    // leftPost
    glPushMatrix();
    glTranslatef(-1.5,2.0,0.0);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
   	gluCylinder(leftPost,0.1,0.1,4.0,10,10);	//radius,radius,height,slices,slices
    glPopMatrix();
    // rightPost
    glPushMatrix();
    glTranslatef(1.5,2.0,0.0);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
   	gluCylinder(rightPost,0.1,0.1,4.0,10,10);	//radius,radius,height,slices,slices
    glPopMatrix();
}

	// a polygon that will form the floor of the world
void floorObject(void)
{
	/* create vertices in anti-clockwise order to have the polygon facing you
     * bottom left, bottom right, top right, top left  (counter-clockwise).
     * By drawing in a counter clockwise order, the square will be facing us.
     * This means we can cull back faces to save processing effort...
     */
    glBegin(GL_POLYGON);
	    // Top Face
		glNormal3f( 0.0f, 1.0f, 0.0f);					// Normal pointing up
		glTexCoord2f(-4.0f, 4.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Point 1 (Top)
		glTexCoord2f(-4.0f, -4.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Point 2 (Top)
		glTexCoord2f(4.0f, -4.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Point 3 (Top)
		glTexCoord2f(4.0f, 4.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Point 4 (Top)
    glEnd();
}


void fieldMarkingsObject(void)
{
	glBegin(GL_LINES);
    	glVertex3f(-12.0,-2.95,-18.0);
        glVertex3f(12.0,-2.95,-18.0);

		glVertex3f(-12.0,-2.95,-16.0);
        glVertex3f(12.0,-2.95,-16.0);

        glVertex3f(-12.0,-2.95,-14.0);
        glVertex3f(12.0,-2.95,-14.0);

        glVertex3f(-12.0,-2.95,-12.0);
        glVertex3f(12.0,-2.95,-12.0);

        glVertex3f(-12.0,-2.95,-10.0);
        glVertex3f(12.0,-2.95,-10.0);

        glVertex3f(-12.0,-2.95,-8.0);
        glVertex3f(12.0,-2.95,-8.0);

        glVertex3f(-12.0,-2.95,-6.0);
        glVertex3f(12.0,-2.95,-6.0);

        glVertex3f(-12.0,-2.95,-4.0);
        glVertex3f(12.0,-2.95,-4.0);

        glVertex3f(-12.0,-2.95,-2.0);
        glVertex3f(12.0,-2.95,-2.0);

        glVertex3f(-12.0,-2.95,0.0);
        glVertex3f(12.0,-2.95,0.0);

        glVertex3f(-12.0,-2.95,2.0);
        glVertex3f(12.0,-2.95,2.0);

        glVertex3f(-12.0,-2.95,4.0);
        glVertex3f(12.0,-2.95,4.0);

        glVertex3f(-12.0,-2.95,6.0);
        glVertex3f(12.0,-2.95,6.0);

        glVertex3f(-12.0,-2.95,8.0);
        glVertex3f(12.0,-2.95,8.0);

        glVertex3f(-12.0,-2.95,10.0);
        glVertex3f(12.0,-2.95,10.0);

        glVertex3f(-12.0,-2.95,12.0);
        glVertex3f(12.0,-2.95,12.0);

        glVertex3f(-12.0,-2.95,14.0);
        glVertex3f(12.0,-2.95,14.0);

        glVertex3f(-12.0,-3.0,16.0);
        glVertex3f(12.0,-3.0,16.0);

        glVertex3f(-12.0,-2.95,18.0);
        glVertex3f(12.0,-2.95,18.0);

        // vertical lines
        glVertex3f(-12.0,-2.95,-18.0);
        glVertex3f(-12.0,-2.95,18.0);

        glVertex3f(12.0,-2.95,-18.0);
        glVertex3f(12.0,-2.95,18.0);
	glEnd();
}

/*
 * Create the 3D objects
 */
void createObjects() {
    // display list for the floor
    glNewList(floor, GL_COMPILE);
    	floorObject();
    glEndList();

    // display list for a field markings
    glNewList(fieldMarkings, GL_COMPILE);
    	fieldMarkingsObject();
    glEndList();

}

void initTextures(void)
{
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_NEAREST);

	// now create the wall & ceiling textures using function by NeHe to read bitmaps
	if (!NeHeLoadBitmap("corrigatedIronTexture.bmp", textures[0]))
    	cout << "failed to load bitmap for wall texture" << endl;
	if (!NeHeLoadBitmap("leopard.bmp", textures[1]))
    	cout << "failed to load bitmap for iist texture" << endl;
	if (!NeHeLoadBitmap("concrete.bmp", textures[2]))
    	cout << "failed to load bitmap for ceiling texture" << endl;
	if (!NeHeLoadBitmap("grass.bmp", textures[3]))
    	cout << "failed to load bitmap for ceiling texture" << endl;

	//glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE); // texture replaces shading effects
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); // texture takes account of shading effects
    glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST); // improve texure mapping to perspective surfaces
}

/************************************************************************
     REPLACEMENT FOR GLAUX by NeHe http://nehe.gamedev.net/
 ************************************************************************
	This is not a full blown bitmap loader.  It is a quick and easy
	way to replace the glAux dependant code in my older tutorials
	with code that does not depend on the glAux library!

    This code only loads Truecolor Bitmap Images.  It will not load
	8-bit bitmaps.  If you encounter a bitmap that will not load
	use a program such as Irfanview to convert the bitmap to 24 bits.
 ************************************************************************/
bool NeHeLoadBitmap(LPTSTR szFileName, GLuint &texid)					// Creates Texture From A Bitmap File
{
	HBITMAP hBMP;														// Handle Of The Bitmap
	BITMAP	BMP;														// Bitmap Structure

	glGenTextures(1, &texid);											// Create The Texture
	hBMP=(HBITMAP)LoadImage(GetModuleHandle(NULL), szFileName, IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_LOADFROMFILE );

	if (!hBMP)															// Does The Bitmap Exist?
		return FALSE;													// If Not Return False

	GetObject(hBMP, sizeof(BMP), &BMP);									// Get The Object
																		// hBMP:        Handle To Graphics Object
																		// sizeof(BMP): Size Of Buffer For Object Information
																		// &BMP:        Buffer For Object Information

	glPixelStorei(GL_UNPACK_ALIGNMENT, 4);								// Pixel Storage Mode (Word Alignment / 4 Bytes)

	// Typical Texture Generation Using Data From The Bitmap
	glBindTexture(GL_TEXTURE_2D, texid);								// Bind To The Texture ID
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);	// Linear Min Filter
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);	// Linear Mag Filter
	glTexImage2D(GL_TEXTURE_2D, 0, 3, BMP.bmWidth, BMP.bmHeight, 0, GL_BGR_EXT, GL_UNSIGNED_BYTE, BMP.bmBits);

	DeleteObject(hBMP);													// Delete The Object

	return TRUE;														// Loading Was Successful
} // end of NeHe stuff

void mainDisplay(void)
{
	glClearColor(0.6,0.6,0.6,0.0);	//grey
	glClear(GL_COLOR_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glLoadIdentity();

    glFlush();
	glutSwapBuffers();
}

void textDisplay(void)
{
	glClearColor(0.3,0.3,0.3,0.0);	//background - grey
	glClear(GL_COLOR_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glLoadIdentity();

	glColor3f(0.0f,1.0f,0.0f);		// green
    drawstr(GLUT_BITMAP_HELVETICA_12,20.0,80.0,"  w,s: walk forward/back");
    drawstr(GLUT_BITMAP_HELVETICA_12,20.0,55.0,"  a,d: turn left/right");
    drawstr(GLUT_BITMAP_HELVETICA_12,20.0,30.0,"  p,l: tilt head up/down");
    drawstr(GLUT_BITMAP_HELVETICA_12,20.0,5.0,"space: pause on/off");

	glFlush();
	glutSwapBuffers();
}

void drawstr(GLvoid *font, GLfloat x, GLfloat y, char* format, ...)
{
    va_list args;
    char buffer[255], *s;

    va_start(args, format);
    vsprintf(buffer, format, args);
    va_end(args);

    glRasterPos2f(x, y);
    for (s = buffer; *s; s++)
        glutBitmapCharacter(font, *s);
}

	/* left and right arrow keys control the direction the viewer is moving
     * up and down arrows determine whether they move forwards or backwards
     */
void keys(unsigned char key, int x, int y)
{
	if (key == 'd' || key == 'D')
	{
		yrot -= 1.5f;							// Rotate The Scene To The Left
	}

	if (key == 'a' || key == 'A')
	{
		yrot += 1.5f;							// Rotate The Scene To The Right
	}
	heading = yrot;
	if (key == 'w' || key == 'W')
	{
		xpos -= (float)sin(heading*piover180) * 0.05f;			// Move On The X-Plane Based On Player Direction
		zpos -= (float)cos(heading*piover180) * 0.05f;			// Move On The Z-Plane Based On Player Direction
		if (walkbiasangle >= 359.0f)					// Is walkbiasangle>=359?
		{
			walkbiasangle = 0.0f;					// Make walkbiasangle Equal 0
		}
		else										// Otherwise
		{
			 walkbiasangle+= 30;					// If walkbiasangle < 359 Increase It By 10
		}
		walkbias = (float)sin(walkbiasangle * piover180)/10.0f;		// Causes The Player To Bounce
	}

	if (key == 's' || key == 'S')
	{
		xpos += (float)sin(heading*piover180) * 0.05f;			// Move On The X-Plane Based On Player Direction
		zpos += (float)cos(heading*piover180) * 0.05f;			// Move On The Z-Plane Based On Player Direction
		if (walkbiasangle <= 1.0f)					// Is walkbiasangle<=1?
		{
			walkbiasangle = 359.0f;					// Make walkbiasangle Equal 359
		}
		else								// Otherwise
		{
			walkbiasangle-= 30;					// If walkbiasangle > 1 Decrease It By 10
		}
		walkbias = (float)sin(walkbiasangle * piover180)/10.0f;		// Causes The Player To Bounce
    }

    if (key == 'l' || key == 'L')   // pgDown makes you tilt head downwards
    {
		lookupdown+= 1.0f;
	}
    if (key == 'p' || key == 'P')	// pgUp makes you tilt head upwards
	{
		lookupdown-= 1.0f;
	}

    if (key == ' ') // space bar to pause
        pause = !pause;    //toggel pause

    redisplayAll();
}

/* set the material for the specified type, which is an index
 * for a predefined array of material properties
 * e.g. myMaterial = theFloor;
 * then call: setMaterial(myMaterial);
 */
void setMaterial(int type)
{
	glMaterialfv(GL_FRONT,GL_SPECULAR,mat_specular[type]);
    glMaterialfv(GL_FRONT,GL_AMBIENT,mat_ambient[type]);
    glMaterialfv(GL_FRONT,GL_DIFFUSE,mat_diffuse[type]);
    glMaterialf(GL_FRONT,GL_SHININESS,mat_shininess[type]);

    glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,mat_emission[type]);
}

	// setup properties for lighting, and initialize the robot
void myInit(void)
{
	glClearColor(0.1,0.5,0.9,0.0);	// sky blue background

    GLfloat light_ambient[]={0.1,0.1,0.1,1.0};
    GLfloat light_diffuse[]={0.6,0.6,0.6,1.0};
    GLfloat light_specular[]={0.8,0.8,0.8,1.0};

    glLightfv(GL_LIGHT0,GL_POSITION,light0_pos);
    glLightfv(GL_LIGHT0,GL_AMBIENT,light_ambient);
    glLightfv(GL_LIGHT0,GL_DIFFUSE,light_diffuse);
    glLightfv(GL_LIGHT0,GL_SPECULAR,light_specular);

    glEnable(GL_SMOOTH);	// smooth shading
    glEnable(GL_LIGHTING);	// enable lighting
    glEnable(GL_LIGHT0);	//turn this particular light on
    glEnable(GL_DEPTH_TEST);

    glEnable(GL_NORMALIZE);	// adjust normals after scaling objects

    // anti-aliasing
    glEnable(GL_POINT_SMOOTH);
	glEnable(GL_LINE_SMOOTH);
    glEnable(GL_POLYGON_SMOOTH);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

    // cull back-faces
    glCullFace(GL_BACK);
    glEnable(GL_CULL_FACE);

    glEnable(GL_TEXTURE_2D);

    // ---------------------------
    // define the robot nodes (from Edward Angel)
    h=gluNewQuadric(); //head					// h is a pointer to a drawing object
    gluQuadricDrawStyle(h, GLU_FILL);
    gluQuadricTexture(h, GL_TRUE);

    t=gluNewQuadric(); //torso
    gluQuadricDrawStyle(t, GLU_FILL);
    gluQuadricTexture(t, GL_TRUE);
    t1=gluNewQuadric();
    gluQuadricDrawStyle(t1, GLU_FILL);
    gluQuadricTexture(t1, GL_TRUE);

    lua=gluNewQuadric(); //left upper arm
    gluQuadricDrawStyle(lua, GLU_FILL);
    gluQuadricTexture(lua, GL_TRUE);

    lla=gluNewQuadric();  //left lower arm
    gluQuadricDrawStyle(lla, GLU_FILL);
    gluQuadricTexture(lla, GL_TRUE);

    rua=gluNewQuadric();  //right upper arm
    gluQuadricDrawStyle(rua, GLU_FILL);
    gluQuadricTexture(rua, GL_TRUE);

    rla=gluNewQuadric();  //right lower arm
    gluQuadricDrawStyle(rla, GLU_FILL);
    gluQuadricTexture(rla, GL_TRUE);

    lul=gluNewQuadric();    //left upper leg
    gluQuadricDrawStyle(lul, GLU_FILL);
    gluQuadricTexture(lul, GL_TRUE);

    lll=gluNewQuadric(); 	//left lower leg
    gluQuadricDrawStyle(lll, GLU_FILL);
    gluQuadricTexture(lll, GL_TRUE);

    rul=gluNewQuadric();  //right upper leg
    gluQuadricDrawStyle(rul, GLU_FILL);
    gluQuadricTexture(rul, GL_TRUE);

    rll=gluNewQuadric();   //right lower leg
    gluQuadricDrawStyle(rll, GLU_FILL);
    gluQuadricTexture(rll, GL_TRUE);

		/* Set up the robot tree for each robot*/
    for (int i=0;i<NBR_ROBOTS;i++)
    {
        // torso
        glLoadIdentity();
        glRotatef(theta[i][0], 0.0, 1.0, 0.0);				//generate a matrix that will position the
        glGetFloatv(GL_MODELVIEW_MATRIX,torso_node[i].m);	// torso to the required starting angle
        torso_node[i].f = torso; 							// the function torso() will draw the torso
        torso_node[i].sibling = NULL;
        torso_node[i].child =  &head_node[i];
        // head
        glLoadIdentity();
        glTranslatef(0.0, TORSO_HEIGHT+0.5*HEAD_HEIGHT, 0.0);
        glRotatef(theta[i][1], 1.0, 0.0, 0.0);
        glRotatef(theta[i][2], 0.0, 1.0, 0.0);
        glGetFloatv(GL_MODELVIEW_MATRIX,head_node[i].m);
        head_node[i].f = head;
        head_node[i].sibling = &lua_node[i];
        head_node[i].child = NULL;
        //left upper arm
        glLoadIdentity();
        glTranslatef(-(0.9*TORSO_RADIUS+UPPER_ARM_RADIUS), 0.8*TORSO_HEIGHT, 0.0);
        glRotatef(theta[i][3], 1.0, 0.0, 0.0);
        glGetFloatv(GL_MODELVIEW_MATRIX,lua_node[i].m);
        lua_node[i].f = left_upper_arm;
        lua_node[i].sibling =  &rua_node[i];
        lua_node[i].child = &lla_node[i];
        //right upper arm
        glLoadIdentity();
        glTranslatef((0.9*TORSO_RADIUS+UPPER_ARM_RADIUS), 0.8*TORSO_HEIGHT, 0.0);
        glRotatef(theta[i][5], 1.0, 0.0, 0.0);
        glGetFloatv(GL_MODELVIEW_MATRIX,rua_node[i].m);
        rua_node[i].f = right_upper_arm;
        rua_node[i].sibling =  &lul_node[i];
        rua_node[i].child = &rla_node[i];
        //left upper leg
        glLoadIdentity();
        glTranslatef(-(0.1*TORSO_RADIUS+UPPER_LEG_RADIUS), -(0.8*TORSO_HEIGHT), -(0.3*TORSO_RADIUS));
        glRotatef(theta[i][7], 1.0, 0.0, 0.0);
        glGetFloatv(GL_MODELVIEW_MATRIX,lul_node[i].m);
        lul_node[i].sibling =  &rul_node[i];
        lul_node[i].f = left_upper_leg;
        lul_node[i].child = &lll_node[i];
        //right upper leg
        glLoadIdentity();
        glTranslatef((0.1*TORSO_RADIUS+UPPER_LEG_RADIUS), -(0.8*TORSO_HEIGHT), -(0.3*TORSO_RADIUS));
        glRotatef(theta[i][9], 1.0, 0.0, 0.0);
        glGetFloatv(GL_MODELVIEW_MATRIX,rul_node[i].m);
        rul_node[i].f = right_upper_leg;
        rul_node[i].sibling =  NULL;
        rul_node[i].child = &rll_node[i];
        //left lower arm
        glLoadIdentity();
        glTranslatef(0.0, 1.3*UPPER_ARM_HEIGHT, 0.0);
        glRotatef(theta[i][4], 1.0, 0.0, 0.0);
        glGetFloatv(GL_MODELVIEW_MATRIX,lla_node[i].m);
        lla_node[i].f = left_lower_arm;
        lla_node[i].sibling =  NULL;
        lla_node[i].child = NULL;
        //right lower arm
        glLoadIdentity();
        glTranslatef(0.0, 1.3*UPPER_ARM_HEIGHT, 0.0);
        glRotatef(theta[i][6], 1.0, 0.0, 0.0);
        glGetFloatv(GL_MODELVIEW_MATRIX,rla_node[i].m);
        rla_node[i].f = right_lower_arm;
        rla_node[i].sibling =  NULL;
        rla_node[i].child = NULL;
        //left lower leg
        glLoadIdentity();
        glTranslatef(0.0, 1.3*UPPER_LEG_HEIGHT, 0.0);
        glRotatef(theta[i][8], 1.0, 0.0, 0.0);
        glGetFloatv(GL_MODELVIEW_MATRIX,lll_node[i].m);
        lll_node[i].f = left_lower_leg;
        lll_node[i].sibling =  NULL;
        lll_node[i].child = NULL;
        //right lower leg
        glLoadIdentity();
        glTranslatef(0.0, 1.3*UPPER_LEG_HEIGHT, 0.0);
        glRotatef(theta[i][10], 1.0, 0.0, 0.0);
        glGetFloatv(GL_MODELVIEW_MATRIX,rll_node[i].m);
        rll_node[i].f = right_lower_leg;
        rll_node[i].sibling =  NULL;
        rll_node[i].child = NULL;
    } // end for each robot

    // define the goal post objects
    upRight=gluNewQuadric();
    gluQuadricDrawStyle(upRight, GLU_FILL);
    crossBar=gluNewQuadric();
    gluQuadricDrawStyle(crossBar, GLU_FILL);
    leftPost=gluNewQuadric();
    gluQuadricDrawStyle(leftPost, GLU_FILL);
    rightPost=gluNewQuadric();
    gluQuadricDrawStyle(rightPost, GLU_FILL);

    glLoadIdentity();

}

    // step forward
void step(int robot)
{
    if (robotX[robot] < commands[robot][currentCommand[robot]+WALK_XCOORD_OFFSET])
        robotX[robot]+=1.0;
    else if (robotX[robot] > commands[robot][currentCommand[robot]+WALK_XCOORD_OFFSET])
        robotX[robot]-=1.0;
    if (robotY[robot] < commands[robot][currentCommand[robot]+WALK_YCOORD_OFFSET])
        robotY[robot]+=1.0;
    else if (robotY[robot] > commands[robot][currentCommand[robot]+WALK_YCOORD_OFFSET])
        robotY[robot]-=1.0;
    if (robotZ[robot] < commands[robot][currentCommand[robot]+WALK_ZCOORD_OFFSET])
        robotZ[robot]+=1.0;
    else if (robotZ[robot] > commands[robot][currentCommand[robot]+WALK_ZCOORD_OFFSET])
        robotZ[robot]-=1.0;
}

void idle2(void)
{
    // what happens during idle():
    // ---------------------------
    // Each time idle() is called, the robot's position and joint angles are updated according to
    // the requirements of the command that is currently being carried out.
    // A command might be walking from one location to another, or it might be spelling out a letter.
    // A command will be carried out over several idle() functions. Each idle() call will do a little
    // bit of the work necessitated by that command. For example, if walking, one call of the idle() function
    // will modify the robot's x,y,z coordinates slightly, so that it is displayed in a new position.
    // The walking command will be worked on in this way until the robot has reached its target position.
    // Then, the current command index will be incremented, so that the subsequent idle() call starts working
    // on the next command.
    // The idle() function will contain different sections of code that are designed to implement aspects of
    // different commands. There will be a way of instructing the execution to run the code sections relevant to
    // the current command.
    // For example, if the current command asks the robot to walk to a certain location, some code that adjusts the
    // robot's coordinates so that it appears to move towards the target destination, and that adjusts its joint
    // angles so as to swing its arms and legs in a walking motion, will be executed.
    // This code will also check whether the command has been completed, and if it has, the command index will
    // be updated to ensure that the next idle() call works on the next command. 
    //
    // Commands:
    //   walking:           the robot's position is changed until it reaches the target destination,
    //                      and while doing this is swings its limbs to resemble walking.
    //   making a letter:   the robot moves its limbs into positions that spell out a letter.
    //
    // Data structures:
    // walking: a walking command would need to contain the following info:
    //      1. parameter name e.g. robotX, robotY, or robotZ
    //      2. target value for that parameter e.g. the x,y,z target coords
    //      how it might work:
    //          the idle() code for walking modifies the robots coordinates until they reach the specified
    //          target values. Also, it goes through the arm/leg/swinging code that causes it to mimic a walking
    //          motion. When all of the target coordinates have been reached, the command is complete.
    // making a letter: a command to spell out a letter would need to contain the following info:
    //      1. parameter name e.g. a particular joint e.g left upper leg, right upper leg etc
    //      2. target value for that joint angle e.g. 180.0, 45.0, etc
    //      how it might work:
    //          the idle() code for making a letter is responsible for modifying the named joint angles
    //          until they reach the specified target values. When all target angles are reached, the command
    //          is complete.
    //
    // We could use an instruction-set like representation:
    //      store commands and command parameters as an array of floats.
    //      The first value in the array is a floating point number that names the first command.
    //      e.g. 1.0 is walk, 2.0 is spell letter 'I', 3.0 is spell letter 'S' etc.
    //      Depending on the command, a certain muber of following values in the array will be its parameters.
    //      e.g for a walk command, the following 3 values in the array will be its x,y,z coordinate targets.
    //      The 4th value in the array will be the next command.
    //      For a 'spell-a-letter' command, there will be one parameter for each of the robot's joint angles.
    //      At any given time, the 'currentCommand' will index the array position of the command that is currently
    //      being executed. When a command has been completed (all of its target paramater values have been reached)
    //      the currentCommand is modified to index the position in the array where the next command is located.
    //      If a walk command has just been completed, this will be currentCommand+4, if a spell-letter command has
    //      just been completed, this will be currentCommand+<however many joint angles there are>

    if (pause)
        return; // don't do anything if paused

    // implementation of commands...
    for (int i=0;i<NBR_ROBOTS;i++)   // for each robot
    {
        // check if we've completed all commands for this robot...
        if (commandsCompleted[i] < nbrCommands)
        {

            //1. what kind of command are we currently carrying out?
            if (commands[i][currentCommand[i]] == 1.0)
            {
                // we're walking...

                // compare my current x,y,z coords with the target coords for this command
                if ((robotX[i] != commands[i][currentCommand[i]+WALK_XCOORD_OFFSET]) ||
                    (robotY[i] != commands[i][currentCommand[i]+WALK_YCOORD_OFFSET]) ||
                    (robotZ[i] != commands[i][currentCommand[i]+WALK_ZCOORD_OFFSET]))
                {
                    // if not all the same, i need to modify my current x,y,z coords so that
                    // i move closer to the target destination...
                    // and this movement will happen as I complete a stride (leg-swing)

                    // stride, by swinging my arms & legs...

                    // arms swinging in time with legs
                    if (stepUpperLeg[i])
                    {
	    	    	    theta[i][3]-=0.5f;	//left upper arm
                        theta[i][5]+=0.5f;  //right upper arm
                    }
                    else
    	            {
			            theta[i][3]+=0.5f;
                        theta[i][5]-=0.5f;
                    }

                    // upper legs swinging
                    if (stepUpperLeg[i])
                    {
	    	        	theta[i][7]+=0.5f;	//left upper leg
                        theta[i][9]-=0.5f;  //right upper leg
                    }
                    else
               	    {
		        	    theta[i][7]-=0.5f;
                        theta[i][9]+=0.5f;
                    }
	                if (theta[i][7] > 225.0)
                    {
        	        	stepUpperLeg[i] = false;
                        stepLowerLeg[i] = false;

                        step(i); // one stride completed, so walk forward one step

                    }
                    if (theta[i][7] < 135.0)
                    {
    		            stepUpperLeg[i] = true;
                        stepLowerLeg[i] = true;

                        step(i); // one stride completed, so walk forward one step
                    }

                    // lower legs swinging
                    if (stepLowerLeg[i])
                    {
                        if (theta[i][10] > 0.0f)
	                	    theta[i][10]-=0.5f;	//right lower leg
                   	    theta[i][8]+=0.5f;	//left lower leg
                    }
                    else
                	{
	                    if (theta[i][8] > 0.0f)	// can't overextend your knee
		    	        	theta[i][8]-=0.5f;			//left lower leg
                        theta[i][10]+=0.5f;	//right lower leg
                    }
                }
                else
                {
                    // if they are all the same, I have finished this walk, so update currentCommand
                    // by adding the offset for walking commands... and thats the end of this idle() call...
                    commandsCompleted[i]++; // keep track of how many commands this robot has completed
                    currentCommand[i]+=WALK_SIZE;  // ready for the next command...
                    cout << "finished walking" << endl;
                }
            } // end of walking command
            else if (commands[i][currentCommand[i]] == 2.0)
            {
                // we're spelling out a letter...

                // compare my current joint angles with the target angles for this command
                // if they are all the same, i have finished this command, so update the currentCommand
                // by adding the offset for spell-letter commands... thats it for this idle()...
                // if not all the same, i need to modify my current joint angles so that they move closer
                // to the target angles.
                if ((theta[i][0] != commands[i][currentCommand[i]+SPELL_TORSO_OFFSET]) ||
                    (theta[i][1] != commands[i][currentCommand[i]+SPELL_HEAD_NOD_OFFSET]) ||
                    (theta[i][2] != commands[i][currentCommand[i]+SPELL_HEAD_TURN_OFFSET]) ||
                    (theta[i][3] != commands[i][currentCommand[i]+SPELL_LUA_FRONT_OFFSET]) ||
                    (theta[i][4] != commands[i][currentCommand[i]+SPELL_LLA_OFFSET]) ||
                    (theta[i][5] != commands[i][currentCommand[i]+SPELL_RUA_FRONT_OFFSET]) ||
                    (theta[i][6] != commands[i][currentCommand[i]+SPELL_RLA_OFFSET]) ||
                    (theta[i][7] != commands[i][currentCommand[i]+SPELL_LUL_OFFSET]) ||
                    (theta[i][8] != commands[i][currentCommand[i]+SPELL_LLL_OFFSET]) ||
                    (theta[i][9] != commands[i][currentCommand[i]+SPELL_RUL_OFFSET]) ||
                    (theta[i][10] != commands[i][currentCommand[i]+SPELL_RLL_OFFSET]) ||
                    (theta[i][11] != commands[i][currentCommand[i]+SPELL_LUA_SIDE_OFFSET]) ||
                    (theta[i][12] != commands[i][currentCommand[i]+SPELL_RUA_SIDE_OFFSET]))
                {
                    // if not all the same, i need to modify my current joint angles so that they move closer
                    // to the target angles.

                    if (theta[i][0] < commands[i][currentCommand[i]+SPELL_TORSO_OFFSET])
                        theta[i][0]+=0.5;
                    else if (theta[i][0] > commands[i][currentCommand[i]+SPELL_TORSO_OFFSET])
                        theta[i][0]-=0.5;
                    if (theta[i][1] < commands[i][currentCommand[i]+SPELL_HEAD_NOD_OFFSET])
                        theta[i][1]+=0.5;
                    else if (theta[i][1] > commands[i][currentCommand[i]+SPELL_HEAD_NOD_OFFSET])
                        theta[i][1]-=0.5;
                    if (theta[i][2] < commands[i][currentCommand[i]+SPELL_HEAD_TURN_OFFSET])
                        theta[i][2]+=0.5;
                    else if (theta[i][2] > commands[i][currentCommand[i]+SPELL_HEAD_TURN_OFFSET])
                        theta[i][2]-=0.5;
                    if (theta[i][3] < commands[i][currentCommand[i]+SPELL_LUA_FRONT_OFFSET])
                        theta[i][3]+=0.5;
                    else if (theta[i][3] > commands[i][currentCommand[i]+SPELL_LUA_FRONT_OFFSET])
                        theta[i][3]-=0.5;
                    if (theta[i][4] < commands[i][currentCommand[i]+SPELL_LLA_OFFSET])
                        theta[i][4]+=0.5;
                    else if (theta[i][4] > commands[i][currentCommand[i]+SPELL_LLA_OFFSET])
                        theta[i][4]-=0.5;
                    if (theta[i][5] < commands[i][currentCommand[i]+SPELL_RUA_FRONT_OFFSET])
                        theta[i][5]+=0.5;
                    else if (theta[i][5] > commands[i][currentCommand[i]+SPELL_RUA_FRONT_OFFSET])
                        theta[i][5]-=0.5;
                    if (theta[i][6] < commands[i][currentCommand[i]+SPELL_RLA_OFFSET])
                        theta[i][6]+=0.5;
                    else if (theta[i][6] > commands[i][currentCommand[i]+SPELL_RLA_OFFSET])
                        theta[i][6]-=0.5;
                    if (theta[i][7] < commands[i][currentCommand[i]+SPELL_LUL_OFFSET])
                        theta[i][7]+=0.5;
                    else if (theta[i][7] > commands[i][currentCommand[i]+SPELL_LUL_OFFSET])
                        theta[i][7]-=0.5;
                    if (theta[i][8] < commands[i][currentCommand[i]+SPELL_LLL_OFFSET])
                        theta[i][8]+=0.5;
                    else if (theta[i][8] > commands[i][currentCommand[i]+SPELL_LLL_OFFSET])
                        theta[i][8]-=0.5;
                    if (theta[i][9] < commands[i][currentCommand[i]+SPELL_RUL_OFFSET])
                        theta[i][9]+=0.5;
                    else if (theta[i][9] > commands[i][currentCommand[i]+SPELL_RUL_OFFSET])
                        theta[i][9]-=0.5;
                    if (theta[i][10] < commands[i][currentCommand[i]+SPELL_RLL_OFFSET])
                        theta[i][10]+=0.5;
                    else if (theta[i][10] > commands[i][currentCommand[i]+SPELL_RLL_OFFSET])
                        theta[i][10]-=0.5;
                    if (theta[i][11] < commands[i][currentCommand[i]+SPELL_LUA_SIDE_OFFSET])
                        theta[i][11]+=0.5;
                    else if (theta[i][11] > commands[i][currentCommand[i]+SPELL_LUA_SIDE_OFFSET])
                        theta[i][11]-=0.5;
                    if (theta[i][12] < commands[i][currentCommand[i]+SPELL_RUA_SIDE_OFFSET])
                        theta[i][12]+=0.5;
                    else if (theta[i][12] > commands[i][currentCommand[i]+SPELL_RUA_SIDE_OFFSET])
                        theta[i][12]-=0.5;

                }
                else
                {
                    // if they are all the same, I have finished this letter, so update currentCommand
                    // by adding the offset for spelling letter commands... and thats the end of this idle() call...
                    currentCommand[i]+=SPELL_LETTER_SIZE;  // ready for the next command...
                    commandsCompleted[i]++;
                    cout << "finished spelling letter" << endl;
                }

            } // end of letter-spelling command

            // now regenerate my matrices to enact the various movements required of the current command
        	// rotate the torso
	    	glLoadIdentity();
            glRotatef(theta[i][0], 0.0, 1.0, 0.0);
    		glGetFloatv(GL_MODELVIEW_MATRIX,torso_node[i].m);

	    	// nod the head
		    glLoadIdentity();
            glTranslatef(0.0, TORSO_HEIGHT+0.5*HEAD_HEIGHT, 0.0);
            glRotatef(theta[i][1], 1.0, 0.0, 0.0);
            glRotatef(theta[i][2], 0.0, 1.0, 0.0);
    		glGetFloatv(GL_MODELVIEW_MATRIX,head_node[i].m);

            // swing the left upper arm
		    glLoadIdentity();
            glTranslatef(-(0.9*TORSO_RADIUS+UPPER_ARM_RADIUS), 0.8*TORSO_HEIGHT, 0.0);
            glRotatef(theta[i][3], 1.0, 0.0, 0.0); // swing arm in plane in front of body
            glRotatef(theta[i][11],0.0,0.0,1.0);   // swing arm in plane to side of body
    	    glGetFloatv(GL_MODELVIEW_MATRIX,lua_node[i].m);

		    //swing the right upper arm
    	    glLoadIdentity();
            glTranslatef((0.9*TORSO_RADIUS+UPPER_ARM_RADIUS), 0.8*TORSO_HEIGHT, 0.0);
            glRotatef(theta[i][5], 1.0, 0.0, 0.0);
            glRotatef(theta[i][12],0.0,0.0,1.0);   // swing arm in plane to side of body
    	    glGetFloatv(GL_MODELVIEW_MATRIX,rua_node[i].m);

    	    //swing the left upper leg
    	    glLoadIdentity();
            glTranslatef(-(0.1*TORSO_RADIUS+UPPER_LEG_RADIUS), -(0.8*TORSO_HEIGHT), -(0.3*TORSO_RADIUS));
            glRotatef(theta[i][7], 1.0, 0.0, 0.0);
    	    glGetFloatv(GL_MODELVIEW_MATRIX,lul_node[i].m);

    	    //swing the right upper leg
	        glLoadIdentity();
            glTranslatef((0.1*TORSO_RADIUS+UPPER_LEG_RADIUS), -(0.8*TORSO_HEIGHT), -(0.3*TORSO_RADIUS));
            glRotatef(theta[i][9], 1.0, 0.0, 0.0);
    	    glGetFloatv(GL_MODELVIEW_MATRIX,rul_node[i].m);

            //swing the left lower arm
	        glLoadIdentity();
            glTranslatef(0.0, UPPER_ARM_HEIGHT, 0.0);
            glRotatef(theta[i][4], 1.0, 0.0, 0.0);
    	    glGetFloatv(GL_MODELVIEW_MATRIX,lla_node[i].m);

	        //swing the right lower arm
	        glLoadIdentity();
            glTranslatef(0.0, UPPER_ARM_HEIGHT, 0.0);
            glRotatef(theta[i][6], 1.0, 0.0, 0.0);
    	    glGetFloatv(GL_MODELVIEW_MATRIX,rla_node[i].m);

	        //swing the left lower leg
    	    glLoadIdentity();
            glTranslatef(0.0, 1.3*UPPER_LEG_HEIGHT, 0.0);
            glRotatef(theta[i][8], 1.0, 0.0, 0.0);
	        glGetFloatv(GL_MODELVIEW_MATRIX,lll_node[i].m);

    	    //swing the right lower leg
	        glLoadIdentity();
            glTranslatef(0.0, 1.3*UPPER_LEG_HEIGHT, 0.0);
            glRotatef(theta[i][10], 1.0, 0.0, 0.0);
    	    glGetFloatv(GL_MODELVIEW_MATRIX,rll_node[i].m);
        } // end if robot has completed all commands
    } // end for each robot

    // restore the matrix
	glPopMatrix();

    glutPostRedisplay();
}


int main(int argc, char* argv[])
{
    // intialise window parameters
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB |  GLUT_DEPTH); // double buffer for animation smoothness
    glutInitWindowSize(500,500);
    glutInitWindowPosition(100,150);

    // create main window
    window = glutCreateWindow("Rob's IIST Robot Cheerleaders");	// the main window
    glutReshapeFunc(myReshape);
    glutDisplayFunc(mainDisplay);
    glutKeyboardFunc(keys);
    glutIdleFunc(idle2);

    // create sub window for the text area
	textWindow = glutCreateSubWindow(window, 10,420, 480, 70); // startX, startY, width, height
    glutDisplayFunc(textDisplay);
    glutReshapeFunc(textReshape);

    // create sub window for the viewing area
    viewingWindow = glutCreateSubWindow(window, 10, 10, 480, 400);
    glutReshapeFunc(myReshape);
    glutDisplayFunc(display);
	glutKeyboardFunc(keys);

    myInit();
    initTextures();	// setup textures

	createObjects();    // Call procedure to create the display list for the IIST logo
    redisplayAll();
    glutMainLoop();
}


